"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Internal = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _merge = require("@codemirror/merge");
var _store = require("./store");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["className", "children", "orientation", "revertControls", "highlightChanges", "gutter", "collapseUnchanged", "renderRevertControl"],
  _excluded2 = ["modified", "original", "view", "dispatch"];
var Internal = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var className = props.className,
    children = props.children,
    orientation = props.orientation,
    revertControls = props.revertControls,
    highlightChanges = props.highlightChanges,
    gutter = props.gutter,
    collapseUnchanged = props.collapseUnchanged,
    renderRevertControl = props.renderRevertControl,
    elmProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var _useStore = (0, _store.useStore)(),
    modified = _useStore.modified,
    original = _useStore.original,
    view = _useStore.view,
    dispatch = _useStore.dispatch,
    otherStore = (0, _objectWithoutProperties2["default"])(_useStore, _excluded2);
  var editor = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      container: editor.current,
      view: view
    };
  }, [editor, view]);
  (0, _react.useEffect)(function () {
    if (!view && editor.current && original && modified) {
      var opts = {
        orientation: orientation,
        revertControls: revertControls,
        highlightChanges: highlightChanges,
        gutter: gutter,
        collapseUnchanged: collapseUnchanged,
        renderRevertControl: renderRevertControl
      };
      var viewDefault = new _merge.MergeView((0, _objectSpread2["default"])({
        a: original,
        b: modified,
        parent: editor.current
      }, opts));
      dispatch && dispatch((0, _objectSpread2["default"])({
        view: viewDefault
      }, opts));
    }
  }, [editor.current, original, modified, view]);
  (0, _react.useEffect)(function () {
    return function () {
      view && view.destroy();
    };
  }, []);
  (0, _react.useEffect)(function () {
    if (view) {
      var opts = {};
      if (otherStore.orientation !== orientation) {
        opts.orientation = orientation;
      }
      if (otherStore.revertControls !== revertControls) {
        opts.revertControls = revertControls;
      }
      if (otherStore.highlightChanges !== highlightChanges) {
        opts.highlightChanges = highlightChanges;
      }
      if (otherStore.gutter !== gutter) {
        opts.gutter = gutter;
      }
      if (otherStore.collapseUnchanged !== collapseUnchanged) {
        opts.collapseUnchanged = collapseUnchanged;
      }
      if (Object.keys(opts).length && dispatch && original && modified && editor.current) {
        view.destroy();
        var viewDefault = new _merge.MergeView((0, _objectSpread2["default"])({
          a: original,
          b: modified,
          parent: editor.current
        }, opts));
        dispatch((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, opts), {}, {
          renderRevertControl: renderRevertControl,
          view: viewDefault
        }));
      }
    }
  }, [view, original, modified, editor, orientation, revertControls, highlightChanges, gutter, collapseUnchanged, renderRevertControl]);
  var defaultClassNames = 'cm-merge-theme';
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    ref: editor,
    className: "".concat(defaultClassNames).concat(className ? " ".concat(className) : '')
  }, elmProps), {}, {
    children: children
  }));
});
exports.Internal = Internal;
Internal.displayName = 'CodeMirrorMerge.Internal';